# This file is a template, and might need editing before it works on your project.
# To contribute improvements to CI/CD templates, please follow the Development guide at:
# https://docs.gitlab.com/ee/development/cicd/templates.html
# This specific template is located at:
# https://gitlab.com/gitlab-org/gitlab/-/blob/master/lib/gitlab/ci/templates/Getting-Started.gitlab-ci.yml

# This is a sample GitLab CI/CD configuration file that should run without any modifications.
# It demonstrates a basic 3 stage CI/CD pipeline. Instead of real tests or scripts,
# it uses echo commands to simulate the pipeline execution.
#
# A pipeline is composed of independent jobs that run scripts, grouped into stages.
# Stages run in sequential order, but jobs within stages run in parallel.
#
# For more information, see: https://docs.gitlab.com/ee/ci/yaml/index.html#stages
variables:
    TEST_NAME: registry.gitlab.com/silviaamoros.informatica/ejemplodespliegue

stages:          # List of stages for jobs, and their order of execution
  - build
  - deploy

build-job:       # This job runs in the build stage, which runs first.
  stage: build
  script:
    - echo "Compiling the code..."
    - docker login -u $GITLABUSER -p $GITLABPASS registry.gitlab.com
    - docker build -t $TEST_NAME .
    - docker push $TEST_NAME
    - echo "Compile complete."
  tags:
    - ci-runner

deploy-job:      # This job runs in the deploy stage.
  stage: deploy  # It only runs when *both* jobs in the test stage complete successfully.
  script:
    - echo "Deploying application..."
    - docker login -u $GITLABUSER -p $GITLABPASS registry.gitlab.com
    - docker pull $TEST_NAME
    - docker kill gitlabCICDContainer || docker ps
    - docker rm gitlabCICDContainer || docker ps
    - docker run -dt -p 82:80 --name gitlabCICDContainer $TEST_NAME
    - echo "Application successfully deployed."
  tags:
    - ci-runner 
